<?php
/**
 * app/plugins/notes/templates/notes.inc.php
 *
 * This is the loader for the notes template.
 *
 * @package TP Notes
 * @version 3.0
 * @author  Joey Kimsey <Joey@thetempusproject.com>
 * @link    https://TheTempusProject.com
 * @license https://opensource.org/licenses/MIT [MIT LICENSE]
 */
namespace TheTempusProject\Templates;

use TheTempusProject\Houdini\Classes\Components;
use TheTempusProject\Houdini\Classes\Navigation;
use TheTempusProject\Houdini\Classes\Views;
use TheTempusProject\Bedrock\Functions\Input;
use TheTempusProject\Models\Notebooks;

class NotesLoader extends DefaultLoader {
    /**
     * This is the function used to generate any components that may be
     * needed by this template.
     */
    public function __construct() {
        $notebooks = new Notebooks;
        Navigation::setCrumbComponent( 'NotebookBreadCrumbs', Input::get( 'url' ) );
        $this->addJs( '<script language="JavaScript" crossorigin="anonymous" type="text/javascript" src="{ROOT_URL}app/plugins/notes/js/notes.js"></script>' );
        parent::__construct();
    }
}
