<!DOCTYPE html>
<html lang="en">
    <!--
     * app/templates/default/default.tpl
     *
     * @version 3.0
     * @author  Joey Kimsey <Joey@thetempusproject.com>
     * @link    https://TheTempusProject.com
     * @license https://opensource.org/licenses/MIT [MIT LICENSE]
    -->
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <meta property="og:url" content="{CURRENT_URL}">
        <meta name='twitter:card' content='summary_large_image' />
        <title>{TITLE}</title>
        <meta itemprop="name" content="{TITLE}">
        <meta name="twitter:title" content="{TITLE}">
        <meta property="og:title" content="{TITLE}">
        <meta name="description" content="{PAGE_DESCRIPTION}">
        <meta itemprop="description" content="{PAGE_DESCRIPTION}">
        <meta name="twitter:description" content="{PAGE_DESCRIPTION}">
        <meta property="og:description" content="{PAGE_DESCRIPTION}">
        <meta itemprop="image" content="{META_IMAGE}">
        <meta name="twitter:image" content="{META_IMAGE}">
        <meta property="og:image" content="{META_IMAGE}">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        {AUTHOR}
        {ROBOT}
        <link rel="icon" href="{ROOT_URL}images/favicon.ico">
        <!-- Required CSS -->
        <link rel="stylesheet" href="{FONT_AWESOME_URL}font-awesome.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="{BOOTSTRAP_CDN}css/bootstrap-theme.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="{BOOTSTRAP_CDN}css/bootstrap.min.css" crossorigin="anonymous">
        <!-- Custom styles for this template -->
        {TEMPLATE_CSS_INCLUDES}
    </head>
    <body>
        <nav class="navbar navbar-inverse navbar-fixed-top" role="navigation">
            <!--Brand and toggle should get grouped for better mobile display but I had to account for additional menus-->
            <div class="navbar-header">
                <a href="{ROOT_URL}" class="navbar-brand">{SITENAME}</a>
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-ex1-collapse" style="">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
            </div>
            <div class="container-fluid">
                <div class="collapse navbar-collapse navbar-ex1-collapse">
                    {topNavLeft}
                    <div class="navbar-right">
                        <ul class="nav navbar-nav">
                            {topNavRight}
                        </ul>
                    </div>
                </div>
            </div>
        </nav>
        <div class="container-fluid top-pad dynamic-footer-padding">
            {ISSUES}
            <div class="container">
                <div class="row">
                    {ERROR}
                    {NOTICE}
                    {SUCCESS}
                    {INFO}
                </div>
            </div>
            {/ISSUES}
            <div class="container">
                    {CONTENT}
            </div>
        </div>
        <footer>
            {FOOT}
            {COPY}
        </footer>
        <!-- Bootstrap core JavaScript and jquery -->
        <script language="JavaScript" crossorigin="anonymous" type="text/javascript" src="{JQUERY_CDN}jquery.min.js"></script>
        <script language="JavaScript" crossorigin="anonymous" type="text/javascript" src="{BOOTSTRAP_CDN}js/bootstrap.min.js"></script>
        <!-- Custom javascript for this template -->
        {TEMPLATE_JS_INCLUDES}
    </body>
</html>